<template>
  <div class="dashboard">
    <div class="top-section">
      <div class="filters">
        <filtered-search
          :fetched-data="fetchedData"
          :submit-search="submitSearch"
          :clear-search="clearSearch"
          context="dashboard"
        />
      </div>

      <gl-alert v-if="showFilterMessage" variant="warning" :dismissible="false">
        Please select either 'Events' or 'Metrics' as type to view the
        dashboard.
      </gl-alert>
      <div v-if="!showFilterMessage">
        <metrics-charts v-if="showChartType === 'metrics'" :rows="rows" />
        <events-charts v-if="showChartType === 'events'" :rows="rows" />
      </div>
    </div>
  </div>
</template>

<script>
import isEmpty from 'lodash/isEmpty'
import { GlAlert } from '@gitlab/ui'
import DataTable from '@/mixins/data-table'
import LocalStorage from '@/mixins/local-storage'
import { DASHBOARD } from '~/assets/constants'

import MetricsCharts from '@/components/metrics_charts.vue'
import EventsCharts from '@/components/events_charts.vue'
import getDataManifest from '@/assets/get-data-manifest'
import FilteredSearch from '@/components/search/filtered_search.vue'
import { extractSearchValues } from '@/assets/utils'
import { getSearchQuery } from '@/assets/get-search-query'

export default {
  components: {
    FilteredSearch,
    GlAlert,
    MetricsCharts,
    EventsCharts,
  },
  mixins: [DataTable, LocalStorage],
  async asyncData() {
    return { dataManifest: await getDataManifest() }
  },

  data() {
    return {
      fetchedData: [],
      metricsData: [],
      eventsData: [],
      rows: [],
      context: DASHBOARD,
      showFilterMessage: false,
      showChartType: 'metrics',
    }
  },
  async mounted() {
    await this.getData()
  },
  methods: {
    async getData() {
      try {
        const searchQuery = getSearchQuery()
        const searchValues = extractSearchValues(searchQuery)

        this.dataUrl = new URL(
          `data/service_ping.${this.dataManifest.service_ping}.json`,
          location.origin,
        ).toString()

        const response = await fetch(this.dataUrl)

        this.eventsDataUrl = new URL(
          `data/snowplow.${this.dataManifest.snowplow}.json`,
          location.origin,
        ).toString()

        const resp = await fetch(this.eventsDataUrl)

        this.metricsData = await response.json()
        this.eventsData = await resp.json()

        if (searchValues?.type?.includes('events')) {
          this.fetchedData = this.eventsData
        } else if (searchValues?.type?.includes('metrics')) {
          this.fetchedData = this.metricsData
        }

        this.rows = this.fetchedData
      } catch (error) {
        // eslint-disable-next-line no-console
        console.error('Error fetching JSON data:', error)
      }
    },
    validateFilters(tokens) {
      if (isEmpty(tokens)) {
        this.showFilterMessage = true
        return
      }

      const searchValues = extractSearchValues(tokens)

      if (!searchValues.type) {
        this.showFilterMessage = true
        return
      }

      if (searchValues.type.includes('events')) {
        this.showChartType = 'events'
        this.showFilterMessage = false
        this.fetchedData = this.eventsData
      } else if (searchValues.type.includes('metrics')) {
        this.showChartType = 'metrics'
        this.showFilterMessage = false
        this.fetchedData = this.metricsData
      }
    },
  },
}
</script>

<style scoped>
.top-section {
  display: flex;
  flex-direction: column;
  gap: 20px;
  margin-bottom: 40px;
  padding: 20px;
  background-color: #f8f9fa;
  border-radius: 10px;
}

.filters {
  display: flex;
  gap: 20px;
  justify-content: center;
  align-items: center;
  padding: 10px;
  background-color: #ffffff;
  border-radius: 10px;
  box-shadow: 0px 4px 15px rgba(0, 0, 0, 0.05);
}

.filters label {
  font-weight: bold;
  font-size: 1rem;
  color: #495057;
}

.filters select {
  padding: 5px 10px;
  border-radius: 5px;
  border: 1px solid #ced4da;
  font-size: 1rem;
  color: #495057;
  transition: all 0.3s ease;
}

.filters select:focus {
  border-color: #007bff;
  outline: none;
}
</style>
